commit 73b82c22d39580458ec9bad544407c874ea0aad5
parent 151d642900284bd2ab7ac92921e4dff028a4e15e
Author: awy <awy@awy.one>
Date: Tue, 5 Nov 2024 14:44:35 +0300
dev
Diffstat:
M | install.sh | | | 185 | ++++++++++++++++++++++++++++++++++++++++++------------------------------------- |
M | post_chroot.sh | | | 92 | ++++++++++++++++++++++++++++++++++++++++---------------------------------------- |
2 files changed, 144 insertions(+), 133 deletions(-)
diff --git a/install.sh b/install.sh
@@ -1,4 +1,4 @@
-#!/bin/bash
+#!/bin/sh
set -e
export red="\033[1;31m"
export green="\033[1;32m"
@@ -10,79 +10,91 @@ dinitctl start ntpd
cpuVendorID=$(grep -m 1 'vendor_id' /proc/cpuinfo | awk '{print $3}')
title() {
- clear
- echo -ne "${cyan}
-################################################################################
-# #
-# This is Automated Artix Linux Installer #
-# #
-# By #
-# #
-# awy :) #
-# #
-################################################################################
-${normal}
-"
+ clear
+ echo "${cyan}
+ ################################################################################
+ # #
+ # This is Automated Artix Linux Installer #
+ # #
+ # By #
+ # #
+ # awy :) #
+ # #
+ ################################################################################
+ ${normal}
+ "
}
diskpart(){
- mkfs.fat -F32 /dev/"$boot_drive"
- mkfs.ext4 -F /dev/"$root_drive"
- mount /dev/"$root_drive" /mnt
- mkdir /mnt/boot
- mkdir /mnt/home
+ mkfs.fat -F32 /dev/"$boot_drive"
+ mkfs.ext4 -F /dev/"$root_drive"
+ mount /dev/"$root_drive" /mnt
+ mkdir /mnt/boot
+ mkdir /mnt/home
}
binKernel(){
- mkdir /mnt/boot/efi
- mount /dev/"$boot_drive" /mnt/boot/efi
- pacman -Sy --confirm
- if [ "$choosenKernel" -eq 1 ]; then
- basestrap /mnt base dinit seatd-dinit linux linux-headers
- elif [ "$choosenKernel" -eq 2 ]; then
- basestrap /mnt base dinit seatd-dinit linux-zen linux-zen-headers
- else
- printf "Wrong kernelflag value.\n"
- exit 1
- fi
+ mkdir /mnt/boot/efi
+ mount /dev/"$boot_drive" /mnt/boot/efi
+ pacman -Sy --confirm
+ if [ "$choosenKernel" = 1 ]; then
+ basestrap /mnt base dinit seatd-dinit linux linux-headers
+ elif [ "$choosenKernel" = 2 ]; then
+ basestrap /mnt base dinit seatd-dinit linux-zen linux-zen-headers
+ else
+ printf "Wrong kernelflag value.\n"
+ exit 1
+ fi
}
customKernel(){
- mount /dev/$boot_drive /mnt/boot
- pacman -Sy --confirm
- basestrap /mnt base dinit seatd-dinit udev
- cp .config /mnt/usr/src
+ mount /dev/"$boot_drive" /mnt/boot
+ pacman -Sy --confirm
+ basestrap /mnt base dinit seatd-dinit udev
+ cp .config /mnt/usr/src
+}
+
+getPass(){
+ stty -echo
+ read -r choice
+ stty echo
+ echo "$choice"
}
getUserData(){
- read -srp "Enter root password: " rootpass
- echo
- read -rp "Enter username: " username
- read -srp "Enter password for $username: " userpass
- echo
- read -rp "Enter hostname: " hostname
- printf ${red}"Choose Linux Kernel:${normal}\n1. Default kernel\n2. Zen kernel\n3. Custom kernel${normal}\nYour choose: "
- read -r choosenKernel
- read -rp "Enter disk label (e.g. sda, nvme0n1p <- p is mandatory in nvme case): " disk_drive
- read -rp "Enter comma-separated partition numbers (e.g., 5,6 for 5 boot 6 root): " partitions
- IFS=',' read -r -a partition_array <<< "$partitions"
- root_drive="$disk_drive${partition_array[1]}"
- boot_drive="$disk_drive${partition_array[0]}"
- while true; do
- clear
- title
- printf ${normal}"Your CPU Vendor detected as ${green}$cpuVendorID${normal}, is that right? Y/N:\n"
- read -r answer
- case "$answer" in
- y|Y)
- break ;;
- n|N)
- echo "Something wrong. Exiting..."
- exit 1 ;;
- *)
- echo "Invalid response. Please enter 'y' or 'n'." && sleep 3 ;;
- esac
- done
+ printf "Enter root password: "
+ rootpass=$(getPass)
+ echo
+ printf "Enter username: "
+ read -r username
+ printf "Enter password for %s: " "$username"
+ userpass=$(getPass)
+ echo
+ printf "Enter hostname: "
+ read -r hostname
+ printf ${red}"Choose Linux Kernel:${normal}\n1. Default kernel\n2. Zen kernel\n3. Custom kernel${normal}\nYour choose: "
+ read -r choosenKernel
+ printf "Enter disk label (e.g. sda, nvme0n1p <- p is mandatory in nvme case): "
+ read -r disk_drive
+ printf "Enter comma-separated partition numbers (e.g., 5,6 for 5 boot 6 root): "
+ read -r partitions
+ root_drive="$disk_drive${partitions%% *}"
+ boot_drive="$disk_drive${partitions## *}"
+ while true; do
+ clear
+ title
+ printf ${normal}"Your CPU Vendor detected as ${green}$cpuVendorID${normal}, is that right? Y/N:\n"
+ read -r answer
+ case "$answer" in
+ y|Y)
+ break ;;
+ n|N)
+ echo "Something wrong. Exiting..."
+ exit 1 ;;
+ *)
+ echo "Invalid response. Please enter 'y' or 'n'." && sleep 3 ;;
+ esac
+ done
}
title
@@ -90,42 +102,40 @@ getUserData
diskpart
case $choosenKernel in
- 1) binKernel ;;
- 2) binKernel ;;
- 3) customKernel ;;
+ 1) binKernel ;;
+ 2) binKernel ;;
+ 3) customKernel ;;
esac
case $cpuVendorID in
- GenuineIntel)
- basestrap /mnt intel-ucode
- if [ "$choosenKernel" -eq 3 ]; then
- pacman -S iucode-tool --noconfirm
- CPUFAM=$(printf '%02x\n' $(lscpu | grep -E '^CPU family:' | awk '{print $3}'))
- MODEL=$(printf '%02x\n' $(lscpu | grep -E '^Model:' | awk '{print $2}'))
- STEPPING=$(printf '%02x\n' $(lscpu | grep -E '^Stepping:' | awk '{print $2}'))
- MICROCODE_PATH="intel-ucode/$CPUFAM-$MODEL-$STEPPING"
- THREAD_NUM=$(nproc)
- sed -i "s#CONFIG_EXTRA_FIRMWARE=.*#CONFIG_EXTRA_FIRMWARE=\"$MICROCODE_PATH\"#g" /mnt/usr/src/.config
- sed -i "s#CONFIG_NR_CPUS=.*#CONFIG_NR_CPUS=$THREAD_NUM#g" /mnt/usr/src/.config
- fi
- ;;
- AuthenticAMD)
- basestrap /mnt amd-ucode ;;
- *)
- printf ${red}"Unsupported CPU Vendor. Possibly there is error in detection script.${normal}\n" && exit 1 ;;
+ GenuineIntel)
+ basestrap /mnt intel-ucode
+ if [ "$choosenKernel" -eq 3 ]; then
+ pacman -S iucode-tool --noconfirm
+ CPUFAM=$(printf '%02x\n' "$(lscpu | grep -E '^CPU family:' | awk '{print $3}')")
+ MODEL=$(printf '%02x\n' "$(lscpu | grep -E '^Model:' | awk '{print $2}')")
+ STEPPING=$(printf '%02x\n' "$(lscpu | grep -E '^Stepping:' | awk '{print $2}')")
+ MICROCODE_PATH="intel-ucode/$CPUFAM-$MODEL-$STEPPING"
+ THREAD_NUM=$(nproc)
+ sed -i "s#CONFIG_EXTRA_FIRMWARE=.*#CONFIG_EXTRA_FIRMWARE=\"$MICROCODE_PATH\"#g" /mnt/usr/src/.config
+ sed -i "s#CONFIG_NR_CPUS=.*#CONFIG_NR_CPUS=$THREAD_NUM#g" /mnt/usr/src/.config
+ fi
+ ;;
+ AuthenticAMD)
+ basestrap /mnt amd-ucode ;;
+ *)
+ printf ${red}"Unsupported CPU Vendor. Possibly there is error in detection script.${normal}\n" && exit 1 ;;
esac
-UUID_ROOT=$(blkid -s UUID -o value /dev/$root_drive)
-UUID_BOOT=$(blkid -s UUID -o value /dev/$boot_drive)
-if [ "choosenKernel" -eq 3 ]; then
+UUID_ROOT=$(blkid -s UUID -o value /dev/"$root_drive")
+UUID_BOOT=$(blkid -s UUID -o value /dev/"$boot_drive")
+if [ "$choosenKernel" = 3 ]; then
echo "UUID=$UUID_BOOT /boot vfat defaults,noatime 0 2" > /mnt/etc/fstab
else
echo "UUID=$UUID_BOOT /boot/efi vfat defaults,noatime 0 2" > /mnt/etc/fstab
fi
echo "UUID=$UUID_ROOT / ext4 defaults,noatime 0 1" >> /mnt/etc/fstab
-_numBoot="${partition_array[0]}"
-export _numBoot
export disk_drive
export root_drive
export boot_drive
@@ -134,6 +144,7 @@ export username
export rootpass
export userpass
export choosenKernel
+export partitions
cp post_chroot.sh /mnt
artix-chroot /mnt ./post_chroot.sh
diff --git a/post_chroot.sh b/post_chroot.sh
@@ -1,4 +1,4 @@
-#!/bin/bash
+#!/bin/sh
set -e
ln -sf /usr/share/zoneinfo/Europe/Moscow /etc/localtime
@@ -18,56 +18,56 @@ echo LANG=en_US.UTF-8 > /etc/locale.conf
export LANG="en_US.UTF-8"
export LC_COLLATE="C"
-echo $hostname > /etc/hostname
-PARTUUID_ROOT=$(blkid -s PARTUUID -o value /dev/$root_drive)
+echo "$hostname" > /etc/hostname
+PARTUUID_ROOT=$(blkid -s PARTUUID -o value /dev/"$root_drive")
binKernel(){
- echo "options hid_apple fnmode=0" > /etc/modprobe.d/hid_apple.conf
- pacman -S grub os-prober efibootmgr --noconfirm
- grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=grub
- GRUB_MODIFIED_LINE='GRUB_CMDLINE_LINUX_DEFAULT="loglevel=3 quiet options root=PARTUUID='$PARTUUID_ROOT' rw nvidia-drm.modeset=1 modeset=1 fbdev=1 intel_iommu=on"'
- sed -i "s/GRUB_CMDLINE_LINUX_DEF\(.*\)/$GRUB_MODIFIED_LINE/g" /etc/default/grub
- sed -i -e 's/MODULES=()/MODULES=(nvidia nvidia_modeset nvidia_uvm nvidia_drm)/g' /etc/mkinitcpio.conf
- if [ "$choosenKernel" -eq 1 ]; then
- pacman -S linux-headers --noconfirm
- elif [ "$choosenKernel" -eq 2 ]; then
- pacman -S linux-zen-headers --noconfirm
- else
- printf "Wrong kernelflag value.\n"
- exit 1
- fi
+ echo "options hid_apple fnmode=0" > /etc/modprobe.d/hid_apple.conf
+ pacman -S grub os-prober efibootmgr --noconfirm
+ grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=grub
+ GRUB_MODIFIED_LINE='GRUB_CMDLINE_LINUX_DEFAULT="loglevel=3 quiet options root=PARTUUID='$PARTUUID_ROOT' rw nvidia-drm.modeset=1 modeset=1 fbdev=1 intel_iommu=on"'
+ sed -i "s/GRUB_CMDLINE_LINUX_DEF\(.*\)/$GRUB_MODIFIED_LINE/g" /etc/default/grub
+ sed -i -e 's/MODULES=()/MODULES=(nvidia nvidia_modeset nvidia_uvm nvidia_drm)/g' /etc/mkinitcpio.conf
+ if [ "$choosenKernel" -eq 1 ]; then
+ pacman -S linux-headers --noconfirm
+ elif [ "$choosenKernel" -eq 2 ]; then
+ pacman -S linux-zen-headers --noconfirm
+ else
+ printf "Wrong kernelflag value.\n"
+ exit 1
+ fi
}
customKernel(){
- latestKernel=$(curl -s https://www.kernel.org/ | grep -A 1 'latest_link' | grep -oP '[0-9]+\.[0-9]+\.[0-9]+' | head -n 1)
- majorVersion=$(echo $latestKernel | cut -d'.' -f1)
- pacman -S efibootmgr --noconfirm
- cd /usr/src/
- curl -Lo /usr/src/linux.tar.xz "https://cdn.kernel.org/pub/linux/kernel/v$majorVersion.x/linux-$latestKernel.tar.xz"
- tar -xf "linux.tar.xz"
- rm -f "linux.tar.xz"
- mv "linux-$latestKernel" "linux"
- cd "linux"
- mv /usr/src/.config .config
- sed -i -e '/^CONFIG_CMDLINE="root=PARTUUID=.*/c\' -e "CONFIG_CMDLINE=\"root=PARTUUID=$PARTUUID_ROOT init=/sbin/dinit-init nvidia_drm.modeset=1 nvidia_drm.fbdev=1\"" .config
- pacman -S bc perl bison make diffutils gcc flex rsync --noconfirm
- make olddefconfig
- make menuconfig
- make -j$(nproc)
- make modules
- make modules_install
- make headers
- make headers_install
- mkdir -p /boot/EFI/BOOT
- cp arch/x86/boot/bzImage /boot/EFI/BOOT/BOOTX64.EFI
- _diskdrivewop="${disk_drive%p}"
- efibootmgr -c -d /dev/$_diskdrivewop -p $_numBoot -L "linux" -l '\EFI\BOOT\BOOTX64.EFI'
+ latestKernel=$(curl -s https://www.kernel.org/ | grep -A 1 'latest_link' | grep -oP '[0-9]+\.[0-9]+\.[0-9]+' | head -n 1)
+ majorVersion=$(echo "$latestKernel" | cut -d'.' -f1)
+ pacman -S efibootmgr --noconfirm
+ cd /usr/src/
+ curl -Lo /usr/src/linux.tar.xz "https://cdn.kernel.org/pub/linux/kernel/v$majorVersion.x/linux-$latestKernel.tar.xz"
+ tar -xf "linux.tar.xz"
+ rm -f "linux.tar.xz"
+ mv "linux-$latestKernel" "linux"
+ cd "linux"
+ mv /usr/src/.config .config
+ sed -i -e '/^CONFIG_CMDLINE="root=PARTUUID=.*/c\' -e "CONFIG_CMDLINE=\"root=PARTUUID=$PARTUUID_ROOT init=/sbin/dinit-init nvidia_drm.modeset=1 nvidia_drm.fbdev=1\"" .config
+ pacman -S bc perl bison make diffutils gcc flex rsync --noconfirm
+ make olddefconfig
+ make menuconfig
+ make -j"$(nproc)"
+ make modules
+ make modules_install
+ make headers
+ make headers_install
+ mkdir -p /boot/EFI/BOOT
+ cp arch/x86/boot/bzImage /boot/EFI/BOOT/BOOTX64.EFI
+ _diskdrivewop="${disk_drive%p}"
+ efibootmgr -c -d /dev/"$_diskdrivewop" -p "${partitions%% *}" -L "linux" -l '\EFI\BOOT\BOOTX64.EFI'
}
case $choosenKernel in
- 1) binKernel && grub-mkconfig -o /boot/grub/grub.cfg ;;
- 2) binKernel && grub-mkconfig -o /boot/grub/grub.cfg ;;
- 3) customKernel ;;
+ 1) binKernel && grub-mkconfig -o /boot/grub/grub.cfg ;;
+ 2) binKernel && grub-mkconfig -o /boot/grub/grub.cfg ;;
+ 3) customKernel ;;
esac
# use dash as sh
@@ -88,10 +88,10 @@ Exec = /usr/bin/ln -sfT dash /usr/bin/sh
Depends = dash
EOL
-useradd -m -g users -G wheel,storage,power -s /bin/zsh $username
+useradd -m -g users -G wheel,storage,power -s /bin/zsh "$username"
-echo root:$rootpass | chpasswd
-echo $username:$userpass | chpasswd
+echo "root:$rootpass" | chpasswd
+echo "$username:$userpass" | chpasswd
cat <<EOL >> /etc/hosts
127.0.0.1 localhost